﻿Public Class AdobeLabel
    Inherits Control

    Public Sub New()
        Me.DoubleBuffered = True
        Me.SetStyle(ControlStyles.AllPaintingInWmPaint Or ControlStyles.UserPaint Or _
                    ControlStyles.SupportsTransparentBackColor Or ControlStyles.OptimizedDoubleBuffer, True)
        Me.SetStyle(ControlStyles.Selectable, False)
        Me.BackColor = AdobeColors.BackgroundColor
    End Sub

    Private m_Text As String = String.Empty

    ''' <summary>
    ''' The text displayed in the <see cref="AdobeLabel" />.
    ''' </summary>
    Public Overrides Property Text() As String
        Get
            Return m_Text
        End Get
        Set(ByVal value As String)
            m_Text = value
            Me.Invalidate()
        End Set
    End Property

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        Dim g As Graphics = e.Graphics
        g.TextRenderingHint = Drawing.Text.TextRenderingHint.ClearTypeGridFit
        g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality

        AdobeStringRenderer.DrawText(g, Me.Text, 12, FontStyle.Regular, 0, 0)
    End Sub
End Class
