﻿<System.ComponentModel.DefaultEvent("CheckedChanged")> _
Public Class AdobeRadioButton
    Inherits AdobeCheckBox

#Region "Event Handlers"
    Protected Overrides Sub OnCheckedChanged(ByVal e As System.EventArgs)
        If Me.Checked AndAlso Me.Parent IsNot Nothing Then
            For Each r As AdobeRadioButton In Me.Parent.Controls.OfType(Of AdobeRadioButton)()
                If r IsNot Me Then r.Checked = False
            Next
        End If
        MyBase.OnCheckedChanged(e)
    End Sub
#End Region

#Region "Drawing"
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        Dim g As Graphics = e.Graphics
        g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        g.TextRenderingHint = Drawing.Text.TextRenderingHint.ClearTypeGridFit

        'Draw the circle
        Dim boxRect As New Rectangle(5, Me.Height \ 2 - AdobeMetrics.CheckBoxSize \ 2, AdobeMetrics.CheckBoxSize, AdobeMetrics.CheckBoxSize)
        If (m_State And AdobeButtonState.Pushed) > 0 Then
            Using backBrush As New SolidBrush(AdobeColors.ButtonPressedColor)
                g.FillEllipse(backBrush, boxRect)
            End Using
        ElseIf (m_State And AdobeButtonState.Hover) > 0 Then
            Using backBrush As New Drawing2D.LinearGradientBrush(boxRect, AdobeColors.ButtonHighlightGradientColor, AdobeColors.ControlHighlightColor, Drawing2D.LinearGradientMode.Vertical)
                g.FillEllipse(backBrush, boxRect)
            End Using
        Else
            Using backBrush As New Drawing2D.LinearGradientBrush(boxRect, AdobeColors.ButtonGradientColor, AdobeColors.ControlGenericColor, Drawing2D.LinearGradientMode.Vertical)
                g.FillEllipse(backBrush, boxRect)
            End Using
        End If

        'Draw the circle's border
        Dim innerbox As Rectangle = boxRect
        'innerbox.Inflate(-1, -1)
        Using innerPen As New Pen(AdobeColors.BorderColor)
            g.DrawEllipse(innerPen, innerbox)
        End Using

        'Draw the check mark
        If Me.Checked Then
            Dim checkbox As Rectangle = innerbox
            checkbox.Inflate(-3, -3)
            g.FillEllipse(Brushes.White, checkbox)
        End If

        'Draw the text
        Dim s As Size = g.MeasureString(Me.Text, AdobeStringRenderer.DefaultFont(12.0!, FontStyle.Regular)).ToSize()
        AdobeStringRenderer.DrawText(g, Me.Text, 12, FontStyle.Regular, 8 + AdobeMetrics.CheckBoxSize, Me.Height \ 2 - s.Height \ 2)
    End Sub
#End Region

    Protected Overrides Sub OnClick(ByVal e As System.EventArgs)
        If Not Me.Checked Then MyBase.OnClick(e) ' Don't allow users to deselect the radio button by clicking it.
    End Sub

End Class