﻿Public NotInheritable Class AdobeStringRenderer
    Private Sub New()
        'Prevent this class from being instantiated
    End Sub

    Public Shared ReadOnly DefaultFontFamily As New FontFamily("Century Gothic") 'Candara
    Public Shared ReadOnly DefaultHeaderSize As Integer = 78
    Public Shared ReadOnly DefaultHeaderFontSize As Integer = 40
    Public Shared ReadOnly DefaultShadowOffset As Integer = 1

    Public Shared ReadOnly Property DefaultFont(ByVal size As Single, ByVal style As FontStyle) As Font
        Get
            Return New Font(AdobeStringRenderer.DefaultFontFamily, size, style, GraphicsUnit.Pixel)
        End Get
    End Property

    Public Shared Sub DrawText(ByVal g As Graphics, ByVal s As String, ByVal size As Integer, ByVal style As FontStyle, ByVal x As Integer, ByVal y As Integer)
        Using f As Font = AdobeStringRenderer.DefaultFont(size, style), shadowBrush As New SolidBrush(AdobeColors.ShadowColor), fontBrush As New SolidBrush(AdobeColors.FontColor)
            g.DrawString(s, f, shadowBrush, x + AdobeStringRenderer.DefaultShadowOffset, y + AdobeStringRenderer.DefaultShadowOffset)
            g.DrawString(s, f, fontBrush, x, y)
        End Using
    End Sub

    Public Shared Sub DrawText(ByVal g As Graphics, ByVal s As String, ByVal size As Integer, ByVal style As FontStyle, ByVal r As Rectangle, ByVal sFmt As StringFormat)
        Using f As Font = AdobeStringRenderer.DefaultFont(size, style), shadowBrush As New SolidBrush(AdobeColors.ShadowColor), fontBrush As New SolidBrush(AdobeColors.FontColor)
            Dim m As Drawing2D.Matrix = g.Transform
            g.TranslateTransform(AdobeStringRenderer.DefaultShadowOffset, AdobeStringRenderer.DefaultShadowOffset)
            g.DrawString(s, f, shadowBrush, r, sFmt)
            g.Transform = m
            g.DrawString(s, f, fontBrush, r, sFmt)
        End Using
    End Sub
End Class
